//This is free and unencumbered software is provided by Cyrstalfontz as an example of
//how to program and use their line of ePaper displays. 
//
//For more information on these displays please visit: http://Crystalfontz.com
//
//Anyone is free to copy, modify, publish, use, compile, sell, or
//distribute this software, either in source code form or as a compiled
//binary, for any purpose, commercial or non - commercial, and by any
//means.
//
//In jurisdictions that recognize copyright laws, the author or authors
//of this software dedicate any and all copyright interest in the
//software to the public domain.We make this dedication for the benefit
//of the public at large and to the detriment of our heirs and
//successors.We intend this dedication to be an overt act of
//relinquishment in perpetuity of all present and future rights to this
//software under copyright law.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
//OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
//ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
//OTHER DEALINGS IN THE SOFTWARE.
//
//For more information, please refer to <http://unlicense.org/>

// digital pins used for the e-paper display 

#define EPD_BUSSEL  2
#define EPD_BUSY    3
#define EPD_RESET   4
#define EPD_DC      5
#define EPD_CS      10

#include <SPI.h>
#include "ePaper.h"
#include "image.h"


#if ((HEIGHT_PIXELS != (296)) || (WIDTH_PIXELS  != (128)))
#error "IMAGE INCLUDE FILE IS WRONG SIZE"
#endif


ePaper Display;

void setup() {

 // Configure the pins to be used by the display
   Display.config_Pins(EPD_BUSY,EPD_RESET,EPD_CS,EPD_DC,EPD_BUSSEL);
   SPI.beginTransaction(SPISettings(500000, MSBFIRST, SPI_MODE0));
   SPI.begin();
}

void loop() {
 // This loop configures the display, writes out the image to be displayed, refreshes the display,
// and then powers off the display. After 20 seconds the loop repeats.

// Note: Many of the commands must be proceeded by a CheckStatus() to ensure the display 
// is not busy before processing another command. Failing to do this will result in corrupted images.
  int i;
  Display.SetPwrReg();
  Display.BoostSoftStart();
  Display.PowerOn();
  Display.CheckStatus();
  Display.SetPanel(); 
  Display.CheckStatus();
  Display.Set_VCOM();
  Display.CheckStatus();
  Display.Set_PLL();
  Display.CheckStatus();
  Display.Set_TempSense();
  Display.CheckStatus();
  Display.Set_Resolution();
  Display.CheckStatus();
  Display.CheckStatus();
  Display.LoadLUTs();
  Display.CheckStatus();
  Display.Set_VCOM_DC(); 
  //Everything up to this point has been done to configure the display 

  // Write the image data out to the display
  Display.CheckStatus();
  Display.WriteFlashImage(DATA_START1,Grey_2BPP,sizeof(Grey_2BPP),false);
  Display.WriteByte(DATA_STOP,CMD);
  
  //Write out the Red data to the display
  Display.CheckStatus(); 
  Display.WriteFlashImage(DATA_START2,Red_1BPP,sizeof(Red_1BPP),false);
  Display.WriteByte(DATA_STOP,CMD);

  //Display the new image. This command takes a while to complete
  Display.CheckStatus();
  Display.Refresh();
  
  // Power off the display
  Display.CheckStatus();
  Display.PowerOff();
  delay(20000);
}
